package model;

import javafx.beans.property.ObjectProperty;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;


public class CapteurCPU extends CapteurAbstrait {
    public CapteurCPU(int id, String nom) {
        super(id, nom);
    }

    @Override
    public ObjectProperty<Double> genTemp() {
        try{
            String temp = new String(Files.readAllBytes(Paths.get("/sys/class/thermal/thermal_zone0/temp")));
            double tempClesius = Double.parseDouble(temp)/1000.0;
            this.setTemp(tempClesius);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return this.getTemp();
    }
}
