package model;

import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleObjectProperty;

import java.util.List;
import java.util.Map;

public class CapteurVirtuel extends CapteurAbstrait {

    private Map<CapteurAbstrait, Integer> capteurs;

    CapteurVirtuel(Map<CapteurAbstrait, Integer> cs, int id, String nom){
        super(id, nom);
        this.capteurs = cs;
    }
    public void addCapteur(CapteurAbstrait c, int p){
        this.capteurs.put(c,p);
    }

   public void removeCapteur(CapteurAbstrait c){
        this.capteurs.remove(c);
    }

    @Override
    // calcule la temperature moyenne des capteurs sa collection de capteurs
    public ObjectProperty<Double> genTemp() {
        double sum = 0;
        int count = 0;
        for (Map.Entry<CapteurAbstrait, Integer> entry : capteurs.entrySet()) {
            CapteurAbstrait c = entry.getKey();
            int p = entry.getValue();
            sum += c.getTemp().getValue() * p;
            count += p;
        }
        double avg = sum / count;
        ObjectProperty<Double> avgProp = new SimpleObjectProperty<>(avg);
        return avgProp;
    }
}
